<mat-card class="crud-card">

  <!--CARD HEADER-->
  <mat-card-header>
    <mat-card-title>
      <h2> Catálogo de Eventos de Agenda</h2>
      <button mat-raised-button color="primary" (click)="openDialog(null)">
        <mat-icon>add</mat-icon>
        Nuevo Evento
      </button>
    </mat-card-title>
    <mat-card-subtitle>

    </mat-card-subtitle>
  </mat-card-header>
  <!--END CARD HEADER-->

  <!--DAtatable action buttons-->
  <mat-card-actions>
    <button mat-raised-button color="primary" (click)="dataSource.loadingSubject.next(true);dataSource.fetchEventTypes(basePaginatorFetcher)">
      <mat-icon>cached</mat-icon>
      Recargar
    </button>
  </mat-card-actions>
  <!--END ACTION BUTTONS-->

  <mat-card-content>

    <!--Search Field-->
    <mat-form-field class="example-full-width" fxLayoutAlign="end">
      <input matInput type="search" placeholder="Buscar" value="" [formControl]="searchInput">
      <button mat-button *ngIf="searchInput.value" matSuffix mat-icon-button aria-label="Clear" (click)="searchInput.setValue('')">
        <mat-icon>close</mat-icon>
      </button>
    </mat-form-field>
    <!--END SEARCH FIELD-->

    <mat-table class="schedule-status-table mat-elevation-z8" [dataSource]="dataSource" matSort matSortActive="name"
      matSortDirection="asc" matSortDisableClear>

      <!--DISPLAYABLE COLUMNS-->
      <ng-container matColumnDef="color">
        <mat-header-cell *matHeaderCellDef>Color</mat-header-cell>
        <mat-header-cell *matCellDef="let scheduleEvent">
          <span class="status-color" [ngStyle]="{'background-color':scheduleEvent.color}"></span>
        </mat-header-cell>
      </ng-container>

      <ng-container matColumnDef="name">
        <mat-header-cell *matHeaderCellDef mat-sort-header>Nombre</mat-header-cell>
        <mat-header-cell *matCellDef="let scheduleEvent">{{scheduleEvent.name}}</mat-header-cell>
      </ng-container>


      <ng-container matColumnDef="created_at">
        <mat-header-cell *matHeaderCellDef>Fecha Creación</mat-header-cell>
        <mat-header-cell *matCellDef="let scheduleEvent">{{scheduleEvent.created_at}}</mat-header-cell>
      </ng-container>

      <ng-container matColumnDef="updated_at">
        <mat-header-cell *matHeaderCellDef>Última Actualización</mat-header-cell>
        <mat-header-cell *matCellDef="let scheduleEvent">{{scheduleEvent.updated_at}}</mat-header-cell>
      </ng-container>

      <ng-container matColumnDef="is_active">
        <mat-header-cell *matHeaderCellDef>Status</mat-header-cell>


        <mat-header-cell *matCellDef="let scheduleEvent">
          <mat-chip-list>
            <mat-chip color="primary" selected *ngIf="scheduleEvent.is_active">Activado</mat-chip>
            <mat-chip color="warn" selected *ngIf="!scheduleEvent.is_active">Desactivado</mat-chip>
          </mat-chip-list>

        </mat-header-cell>
      </ng-container>

      <ng-container matColumnDef="actions">
        <mat-header-cell *matHeaderCellDef>Acciones</mat-header-cell>
        <mat-header-cell *matCellDef="let scheduleEvent">

          <button mat-raised-button color="primary" (click)="openDialog(scheduleEvent)">
            <mat-icon>edit</mat-icon>
            Editar
          </button>

          <button mat-raised-button [color]="scheduleEvent.is_active?'warn':'primary'" (click)="setEventAvailability(scheduleEvent)">
            <mat-icon>{{scheduleEvent.is_active ? 'cancel':'check'}}</mat-icon>
            {{scheduleEvent.is_active ? 'Desactivar' : 'Activar'}}
          </button>

        </mat-header-cell>
      </ng-container>
      <!--END DISPLAYABLE COLUMNS-->



      <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
      <mat-row *matRowDef="let row; columns: displayedColumns"></mat-row>

    </mat-table>



    <!--Datatable loader-->
    <mat-card *ngIf="dataSource.loading$|async; checkEmpty" style="display: flex; justify-content: center; align-items: center">
      <mat-progress-spinner color="primary" mode="indeterminate">
      </mat-progress-spinner>
    </mat-card>
    <!--END DATATABLE LOADER-->

    <!--EMPTY DATATABLE DATA-->
    <mat-card #checkEmpty *ngIf="dataSource.eventsTypeData.value == null " style="display: flex; justify-content: center; align-items: center">
      <p>No hay tipos de evento registrados</p>
    </mat-card>
    <!--END EMPYT DATATABLE DATAƒ-->




    <!--DATATABLE  PAGINATOR-->
    <mat-paginator [length]="dataSource.noPages$ |async " [pageSize]="10" [pageSizeOptions]="[10,20,30,50]" class="mat-elevation-z8">
    </mat-paginator>
    <!--END DATATABLE PAGINATOR-->

  </mat-card-content>

</mat-card>